.686
.model flat,stdcall
option casemap:none
 .LISTMACROALL
 .NOLIST
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
INCLUDE \MASM32\INCLUDE\GDI32.INC
INCLUDE \MASM32\INCLUDE\MASM32.INC
INCLUDE \MASM32\MACROS\MACROS.ASM
INCLUDE \MYSTUFF\MYSTUFF.INC
 .LIST
INCLUDELIB \MASM32\LIB\USER32.LIB
INCLUDELIB \MASM32\LIB\KERNEL32.LIB
INCLUDELIB \MASM32\LIB\GDI32.LIB
INCLUDELIB \MASM32\LIB\GDI32.LIB
INCLUDELIB \MASM32\LIB\MASM32.LIB

D EQU DWORD PTR
@ EQU OFFSET

CRI STRUCT
 DrugDose	DWORD	?	  ; example: 1.25
 FluidRate	DWORD	?	  ; example (ml/hr): 8.3
 FluidVol	DWORD   ?	  ; example (ml): 1000
 DrugForm	BYTE 32 dup (?)   ; example: "Metoclopramide 5.0 mg/ml"
 DrugUnits	BYTE 12 dup (?)   ; example: "mg/kg/day"
CRI ENDS

 .DATA?
 Prescription BYTE 12*CRI DUP (?)

 .DATA
DDose REAL4 1.25
FR    REAL4 8.3
DrugF BYTE 'Metoclopramide 5.0 mg/ml',0
DUnit BYTE 'mg/kg/day',0

 .CODE
START:
 MOV ESI,CRI                       ;ESI=size of CRI structure
 SHL ESI,3                         ;ESI=8 times CRI structure
 ADD ESI,CRI+@ Prescription        ;ESI=address of 10th element of array

 MOV EAX,[DDose]
 MOV [ESI.CRI.DrugDose],EAX        ;copy into 10th element of array
 MOV EAX,[FR]
 MOV [ESI.CRI.FluidRate],EAX       ;copy into 10th element of array
 MOV EAX,1000
 MOV [ESI.CRI.FluidVol],EAX        ;copy into 10th element of array

 LEA ECX,[ESI.CRI.DrugForm]
 INVOKE lstrcpy,ECX,@ DrugF        ;copy into 10th element of array

 LEA ECX,[ESI.CRI.DrugUnits]
 INVOKE lstrcpy,ECX,@ DUnit        ;copy into 10th element of array

 INVOKE ExitProcess,EBP
END START



